<?php
// +----------------------------------------------------------------------
// | 消息中心，获取失败日志列表
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\api\message_center;
use think\Db;

class get_list {
   
    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @param swoole $ws 实例
     * @param swoole $request 请求体信息
     * @param response $response 请求内容 来源类实例也在里面
     * @return void
    */
    public function run($ws, $request, $response) {
        # 获取请求参数，不区分请求类型，POST优先
        $param = $response->class->param($request);
        # 可以这样判断请求类型
        if ($request->server['request_method'] != 'GET') {
            # 如果需要返回消息，可以这样
            $response->class->endRequest($request, $response, '301', '请求类型错误');
            # 注意，在接口中不能exit，否则会报错的
            return false;
        }

        # 获取mysql连接
        $read_obj = \pool\MysqlPool::run()->read_pop();
        $read_db = $read_obj['db'];

        $where = $this->_where($param);
        $page = !empty($param['page']) ? $param['page'] : 1;
        $limit = !empty($param['limit']) ? $param['limit'] : 20;
        $table = $ws->config['websocket_redis_message_center_table'];
        # 查询列表
        $sql = \db\SwooleDb::run()->table($table.'_log')->where($where)->page($page, $limit)->order('id DESC')->select();
        $list = $read_db->query($sql);

        # 查询出页数
        $sql = \db\SwooleDb::run()->table($table.'_log')->where($where)->field('count(id) AS num')->find();
        $info = $read_db->query($sql);

        # 归回连接
        \pool\MysqlPool::run()->read_free($read_obj);

        $response->class->endRequest($request, $response, '200', '获取成功', [
            'total' => ceil($info[0]['num'] / $limit),
            'list' => $list
        ]);
        return true;
    }

    /**
     * 查询条件构造
     * @todo 无
     * @author 小黄牛
     * @version v1.0.12 + 2020.04.29
     * @deprecated 暂不启用
     * @global 无
     * @param array $param
     * @return array
    */
    public function _where($param=[]) {
        $where = [];
        if (!empty($param['action'])) {
            $where[] = ['action', 'like', "%".$param['action']."%"];
        }
        if (!empty($param['fd'])) {
            $where[] = ['fd', '=', $param['fd']];
        }
        if (!empty($param['start_time'])) {
            $where[] = ['create_time', '<=', strtotime($param['start_time'])];
        }
        if (!empty($param['end_time'])) {
            $where[] = ['create_time', '>', strtotime($param['end_time'])+86399];
        }

        return $where;
    }
    
    /**
     * 该接口文档说明
     * @author 小黄牛
     * @version v1.0.1 + 2020.02.24
    */
    public function _link() {
        return [
            // 请求头
            'header' => [
                'method' => 'GET', // 请求类型
                'code' => 'utf-8', // 内容编码
                'content-type' => 'application/x-www-form-urlencoded', // 数据类型
                // 其余自定义header
            ],
            // 请求参数
            'param' => [
                // 参考格式
                'action' => '', // 事件 string(32) 默认null 可为空
                'fd' => '', // 连接标识 int(11) 默认null 可为空
                'start_time' => '', // 开始时间 date 默认null 可为空
                'end_time' => '', // 结束时间 date 默认null 可为空
                'page' => '1', // 查询页数 int(11) 默认1 可为空
                'limit' => '20', // 每页记录数 int(11) 默认20 可为空
            ],
            // 返回值
            'return' => [
                // 状态码囊括
                'code' => [
                    '200' => '请求正常', 
                    '301' => '错误提示', 
                    '500' => '服务器错误',
                ],
                // data部分返回值说明
                'data' => [
                    'total' => 10, // 总页数
                    'list' => [ // 结果集
                        'id' => '', // ID
                        'action' => '',// 事件
                        'fd' => '', // FD
                        'data' => '', // 推送data
                        'create_time' => '', // 最后失败的时间戳
                        'num' => '', // 历史失败次数
                    ]
                ]
            ]
        ];
    }
}
