<?php
// +----------------------------------------------------------------------
// | 消息中心任务重复
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\crontab;
use think\Db;

class message_center_work {

    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public function run($ws) {
        \Swoole\Timer::tick($ws->config['websocket_redis_message_center_work_time'] * 1000, function ($timer_id) use (&$ws) {
            # 获取redis连接
            $redis_obj = \pool\RedisPool::run()->pop();
            $redis = $redis_obj['redis'];
            # 获取mysql连接
            $read_obj = \pool\MysqlPool::run()->read_pop();
            $read_db = $read_obj['db'];
            $write_obj = \pool\MysqlPool::run()->write_pop();
            $write_db = $write_obj['db'];

            # 获取读取key
            $redis_key = $ws->config['websocket_redis_message_center'].'work_keys';
            $last_id = $redis->get($redis_key);
            if ($last_id == false) {
                $last_id = 0;
            }

            # 获取必备参数
            $table = $ws->config['websocket_redis_message_center_table'];
            $limit = $ws->config['websocket_redis_message_center_work_max'];

            # 查出所有
            $sql = \db\SwooleDb::run()->table($table.'_work')->where('id', '>', $last_id)->limit($limit)->order('id ASC')->select();
            $list = $read_db->query($sql);
            # 遍历重发
            foreach ($list as $v) {
                # 更新最后ID
                $last_id = $v['id'];
                unset($v['id']);
                $v['num']++;
                $v['create_time'] = time();
                # 不管发没发出先删掉这条记录
                $sql = \db\SwooleDb::run()->table($table.'_work')->where('id', $last_id)->delete();
                $write_db->query($sql);
                # 重发消息
                $res = \app\socket\controller\vendor\Tool::againReturn($ws, $v['fd'], $v['data']);
                # NND，又发送失败了，好害怕~
                if (!$res) {
                    # 算下失败次数再说
                    if ($v['num'] >= $ws->config['websocket_redis_message_center_num']) {
                        # 写到LOG吧没救了
                        $sql = \db\SwooleDb::run()->table($table.'_log')->insert($v);
                    } else {
                        # 回写队列，下一次再来过
                        $sql = \db\SwooleDb::run()->table($table.'_work')->insert($v); 
                    }
                    $res = $write_db->query($sql);
                    if (!$res) {
                        # 如果担心丢失，这里写下file LOG吧
                    }
                }
            }
            # 更新key
            $redis->set($redis_key, $last_id);
            # 归回连接
            \pool\MysqlPool::run()->read_free($read_obj);
            \pool\MysqlPool::run()->write_free($write_obj);
            # 归还连接
            \pool\RedisPool::run()->free($redis_obj);
        });
    }
}
